<template lang="">
    <div class="flex-container">
        <h1>TRIVIA GAME</h1>
        <!--Creating selector item for the question amount-->
        <div class="selector-container">
            <!--binding the default input value to the state.amount-->
            <label class="selector-label" for="trivia_amount">AMOUNT: </label>
            <input class="selector-input" v-on:change="onChangeAmount" type="number" id="trivia_amount" 
            min="1" max="20" v-bind:value="amount">
        </div>
        
        <!--Creating selector item for the question difficulty-->
        <div class="selector-container">
            <label class="selector-label" for="trivia_difficulty">DIFFICULTY: </label>
            <!--binding the default input value to the state.difficulty-->
                <select class="selector-input" v-on:change="onChangeDifficulty" id="trivia_difficulty" v-bind:value="difficulty">
                <option value="">ANY</option>
                <option value="easy">Easy</option>
                <option value="medium">Medium</option>
                <option value="hard">Hard</option>
            </select>
        </div>

        <!--Creating selector item for the question category-->
        <div class="selector-container">
            <label class="selector-label" for="trivia_category">CATEGORY: </label>
            <!--binding the default input value to the state.category-->
            <select class="selector-input" v-on:change="onChangeCategory" id="trivia_category" v-bind:value="category">
                <option value="">ANY</option>
                <option value="9">General Knowledge</option>
                <option value="10">Entertainment: Books</option>
                <option value="11">Entertainment: Film</option>
                <option value="12">Entertainment: Music</option>
                <option value="13">Entertainment: Musicals &amp; Theatres</option>
                <option value="14">Entertainment: Television</option>
                <option value="15">Entertainment: Video Games</option>
                <option value="16">Entertainment: Board Games</option>
                <option value="17">Science &amp; Nature</option>
                <option value="18">Science: Computers</option>
                <option value="19">Science: Mathematics</option>
                <option value="20">Mythology</option>
                <option value="21">Sports</option>
                <option value="22">Geography</option>
                <option value="23">History</option>
                <option value="24">Politics</option>
                <option value="25">Art</option>
                <option value="26">Celebrities</option>
                <option value="27">Animals</option>
                <option value="28">Vehicles</option>
                <option value="29">Entertainment: Comics</option>
                <option value="30">Science: Gadgets</option>
                <option value="31">Entertainment: Japanese Anime &amp; Manga</option>
                <option value="32">Entertainment: Cartoon &amp; Animations</option>		
            </select>
        </div>

        <!--the play button, animated-->
        <button class="play-button" @click="onPlayClick">PLAY</button>  
    </div>
</template>
<script>

import { mapActions, mapState } from 'vuex'

export default {
    name: 'Start',
    methods: {
        //mapping actions
        ...mapActions([ 'updateAmount',
                        'updateDifficulty',
                        'updateCategory',
                        'fetchSessionKey' ]),
        //route when user presses play button
        onPlayClick() {
            this.$router.push('/question')
        },

        //Tracking user changes to their settings
        onChangeAmount(event) {
            this.updateAmount(event.target.value)
        },
        onChangeDifficulty(event) {
            this.updateDifficulty(event.target.value)
        },
        onChangeCategory(event) {
            this.updateCategory(event.target.value)
        },
    },
    computed: {
        ...mapState([ 'difficulty',
                    'amount',
                    'category' ])
    },
    created() {
        //Generate a token if we do not have a token
        //The token prevents duplicate questions until all questions are exhausted
        if (this.$store.state.sessionToken === '')  {
            this.fetchSessionKey()
        }
            
    }
}
</script>
    
<style scoped>
/* stylign the selector label */
.selector-label {
    background-color: rgb(178, 217, 219);
    font-weight: bolder;
    margin: 0.5rem;
    padding: 0.4rem;
    border-radius: 1rem;
    text-align: center;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
}
/* styling the selector input box*/
.selector-input {
    background-color: rgb(178, 217, 219);
    border-radius: 1rem;
    padding: 0.4rem;
    text-align: center;
    font-weight: bolder;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
}
.flex-container {
    /* centering items */
    display: flex;
	flex-direction: column;
	flex-wrap: nowrap;
	justify-content: center;
	align-items: center;
	align-content: flex-start;
}

/* creating margin around the selectors */
.selector-container {
    margin: 0.7rem;
}

/* animation for the play button */
@keyframes switchColors {
  from {background-color: rgb(82, 12, 12);}
  to {background-color: rgb(3, 3, 46);}
}

/* styling play button and adding animation */
.play-button {
    color: rgb(233, 233, 177);
    background-color: rgb(2, 2, 12);
    animation-name: switchColors;
    animation-duration: 2s;
    animation-iteration-count: infinite;
    font-size: 2rem;
    font-weight: lighter;
}
</style>